<?xml version="1.0" encoding="UTF-8"?>
<!-- Copyright (c) 2015 Cisco and/or its affiliates. Licensed under the Apache
    License, Version 2.0 (the "License"); you may not use this file except in
    compliance with the License. You may obtain a copy of the License at: http://www.apache.org/licenses/LICENSE-2.0
    Unless required by applicable law or agreed to in writing, software distributed
    under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES
    OR CONDITIONS OF ANY KIND, either express or implied. See the License for
    the specific language governing permissions and limitations under the License. -->
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <parent>
        <groupId>com.orange.honeynode</groupId>
        <artifactId>honeynode-plugin-aggregator</artifactId>
        <version>7.1.10-SNAPSHOT</version>
    </parent>
    <modelVersion>4.0.0</modelVersion>
    <artifactId>minimal-distribution</artifactId>
    <name>${project.artifactId}</name>
    <properties>
        <main.class>io.fd.honeycomb.infra.distro.Main</main.class>
        <distribution.modules>
            io.fd.honeycomb.infra.distro.schema.YangBindingProviderModule,
            io.fd.honeycomb.infra.distro.schema.SchemaModule,
            io.fd.honeycomb.infra.distro.data.ConfigAndOperationalPipelineModule,
            io.fd.honeycomb.infra.distro.data.context.ContextPipelineModule,
            io.fd.honeycomb.infra.distro.initializer.InitializerPipelineModule,
            io.fd.honeycomb.northbound.CredentialsModule,
            io.fd.honeycomb.northbound.netconf.NetconfModule,
            io.fd.honeycomb.northbound.netconf.NetconfReadersModule,
            io.fd.honeycomb.northbound.restconf.RestconfModule,
            io.fd.honeycomb.infra.distro.cfgattrs.CfgAttrsModule,
            //io.fd.honeycomb.infra.bgp.BgpModule,
            //io.fd.honeycomb.infra.bgp.BgpReadersModule,
            //io.fd.honeycomb.infra.bgp.BgpWritersModule,
            //io.fd.honeycomb.northbound.bgp.extension.EvpnModule,
            //io.fd.honeycomb.northbound.bgp.extension.InetModule,
            //io.fd.honeycomb.northbound.bgp.extension.L3VpnV4Module,
            //io.fd.honeycomb.northbound.bgp.extension.L3VpnV6Module,
            //io.fd.honeycomb.northbound.bgp.extension.LabeledUnicastModule,
            // io.fd.honeycomb.northbound.bgp.extension.LinkstateModule,
            // io.fd.honeycomb.footprint.FootprintModule
        </distribution.modules>
    </properties>
    <dependencyManagement>
        <dependencies>
            <dependency>
                <groupId>io.fd.honeycomb.common</groupId>
                <artifactId>minimal-distribution-parent</artifactId>
                <version>${honeycomb.version}</version>
            </dependency>
        </dependencies>
    </dependencyManagement>
    <dependencies>
        <!-- DI -->
        <dependency>
            <groupId>com.google.inject</groupId>
            <artifactId>guice</artifactId>
        </dependency>
        <!-- TPCE Distribution core -->
        <dependency>
            <groupId>com.orange.honeynode</groupId>
            <artifactId>minimal-distribution-core</artifactId>
        </dependency>
        <dependency>
            <groupId>com.orange.honeynode</groupId>
            <artifactId>restconf</artifactId>
        </dependency>
        <dependency>
            <groupId>com.orange.honeynode</groupId>
            <artifactId>netconf</artifactId>
        </dependency>
        <!-- Northbound interfaces -->
        <dependency>
            <groupId>io.fd.honeycomb.northbound</groupId>
            <artifactId>common</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound</groupId>
            <artifactId>bgp</artifactId>
            <version>${honeycomb.version}</version>
            <exclusions>
                <exclusion>
                    <groupId>io.fd.honeycomb</groupId>
                    <artifactId>minimal-distribution-core</artifactId>
                </exclusion>
            </exclusions>
        </dependency>
        <!-- Bgp extension modules -->
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>extension-common</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>evpn</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>inet</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>l3-vpn-v4</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>l3-vpn-v6</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>linkstate</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <dependency>
            <groupId>io.fd.honeycomb.northbound.bgp</groupId>
            <artifactId>labeled-unicast</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
        <!-- Footprint api -->
        <dependency>
            <groupId>io.fd.honeycomb.footprint</groupId>
            <artifactId>impl</artifactId>
            <version>${honeycomb.version}</version>
        </dependency>
    </dependencies>
    <build>
        <plugins>
            <plugin>
                <artifactId>maven-assembly-plugin</artifactId>
                <version>2.5.3</version>
                <executions>
                    <execution>
                        <id>create-archive</id>
                        <phase>package</phase>
                        <goals>
                            <goal>single</goal>
                        </goals>
                        <configuration>
                            <descriptorRefs>
                                <descriptorRef>honeycomb-minimal</descriptorRef>
                            </descriptorRefs>
                        </configuration>
                    </execution>
                </executions>
                <dependencies>
                    <dependency>
                        <groupId>io.fd.honeycomb.common</groupId>
                        <artifactId>minimal-assembly-descriptor</artifactId>
                        <version>${honeycomb.version}</version>
                        <scope>compile</scope>
                    </dependency>
                </dependencies>
            </plugin>
            <plugin>
                <artifactId>maven-jar-plugin</artifactId>
                <version>2.6</version>
                <configuration>
                    <archive>
                        <manifest>
                            <mainClass>io.fd.honeycomb.infra.distro.Main</mainClass>
                            <addClasspath>true</addClasspath>
                            <classpathPrefix>lib/</classpathPrefix>
                            <useUniqueVersions>false</useUniqueVersions>
                            <classpathMavenRepositoryLayout>true</classpathMavenRepositoryLayout>
                        </manifest>
                        <manifestEntries>
                            <Class-Path>config/ cert/ modules/
                                yang-mapping/</Class-Path>
                        </manifestEntries>
                    </archive>
                </configuration>
            </plugin>
            <plugin>
                <artifactId>maven-dependency-plugin</artifactId>
                <executions>
                    <execution>
                        <id>copy-dependencies</id>
                        <phase>process-sources</phase>
                        <goals>
                            <goal>copy-dependencies</goal>
                        </goals>
                        <configuration>
                            <outputDirectory>${project.build.directory}/lib</outputDirectory>
                            <useBaseVersion>true</useBaseVersion>
                            <useRepositoryLayout>true</useRepositoryLayout>
                            <excludeArtifactIds>yang-jmx-generator,test-api</excludeArtifactIds>
                        </configuration>
                    </execution>
                    <execution>
                        <id>unpack-configuration</id>
                        <phase>prepare-package</phase>
                        <goals>
                            <goal>unpack-dependencies</goal>
                        </goals>
                        <configuration>
                            <includes>**/honeycomb-minimal-resources/</includes>
                            <outputDirectory>${project.build.directory}/classes/</outputDirectory>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <groupId>org.codehaus.gmavenplus</groupId>
                <artifactId>gmavenplus-plugin</artifactId>
                <executions>
                    <execution>
                        <id>start-scripts-generation</id>
                        <phase>package</phase>
                        <goals>
                            <goal>execute</goal>
                        </goals>
                        <configuration>
                            <scripts>
                                <script>import io.fd.honeycomb.common.scripts.StartupScriptGenerator
                                                          StartupScriptGenerator.generate(project,properties, log)</script>
                            </scripts>
                        </configuration>
                    </execution>
                    <execution>
                        <id>distribution-module-assembly</id>
                        <phase>prepare-package</phase>
                        <goals>
                            <goal>execute</goal>
                        </goals>
                        <configuration>
                            <scripts>
                                <script>import io.fd.honeycomb.common.scripts.ModulesListGenerator
                                                          ModulesListGenerator.generate(project,log)</script>
                            </scripts>
                        </configuration>
                    </execution>
                    <execution>
                        <id>generate-module-to-yang-index</id>
                        <phase>prepare-package</phase>
                        <goals>
                            <goal>execute</goal>
                        </goals>
                        <configuration>
                            <scripts>
                                <script>import io.fd.honeycomb.common.scripts.ModuleYangIndexGenerator
                                                          ModuleYangIndexGenerator.pairDistributionModulesWithYangModules(project,log)</script>
                            </scripts>
                        </configuration>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>
